/*
Антон (Лилой) Москаленко
e-mail: liloi@mail.ru

void ras_sys(int sys_num, int numb, int res[])

sys_num - система счисления (например 2 - двоичная сист., 3 - троичная сист. и.т.д.)
numb - число, которое нужно разложить по фор. 1
res[] - запись результата

Фор. 1: mn*b^n + m(n-1)*n^(n-1) + ... + m3*b^3 + m2*b^2 + m1*b^1 + m0*b^0, где
    b - система счистления (т.е. sys_num)
    числа (m0, m1, m2, ... , m(n-1), mn) - то, на что наше число нужно разложить
    
Пример:
    
    int a[10] = {0,0,0,0,0,0,0,0,0,0};
    int e = 16;
    
    ras_sys(e,300,a);

    for(int i=10;i>=0;i--)
    {
        cout << a[i] << "*" << e << "^" << i << " + ";
    }

В результате мы получим на выводе:

0*16^10 + 0*16^9 + 0*16^8 + 0*16^7 + 0*16^6 + 0*16^5 + 0*16^4 + 0*16^3 + 1*16^2+ 2*16^1 + 12*16^0 +

т.е. 1*16^2+ 2*16^1 + 12*16^0

т.е. 12С   


P.S. Алгоритм правильно ракладывает только целые неотрицательные числа при общей
заданной sys_num > 0

*/

#ifndef RASKL_SYS
#define RASKL_SYS
 
void ras_sys(unsigned int sys_num, unsigned int numb, int res[])
{
    int l = 0;

    re2:l = 0;
    
    if(numb==0)goto out;
    
    numb--;
    res[l]++;
    
    if(res[l]>=sys_num)
    {
        res[l] = 0;
        res[l+1]++;
        re:if(res[l+1]>=sys_num)
        {
            res[l+1] = 0;
            l++;
            res[l+1]++;
            goto re;
        } else goto re2;
    } else goto re2;
    
    out:{}
}

#endif

//
